var mkTarget;

function qrCode(strURL, strLabel) {
	var result = $.ajax({
		url: 'ajax.php?chrAction=HQRC&strURL=' + strURL + '&strLabel=' + strLabel
	}).always(function() {
		var arrResult 	= JSON.parse(result.responseText);
		window.location	= 'output.php?strName=' + strLabel + '.png&strFileName=' + arrResult['strFilePathTMP'];
	});
}

function showLoadingFullScreen(blnShow) {
	document.getElementById("divLoadingFullScreen").style.display = (blnShow > 0 ? "block" : "none");
}

function mapShowLoading(blnShow) {
	//map.setOptions({draggable: !blnShow, zoomControl: !blnShow, scrollwheel: !blnShow, disableDoubleClickZoom: !blnShow});
	document.getElementById("divMapLoading").style.display = (blnShow > 0 ? "block" : "none");
}

function cancelFullScreen(el) {
	var requestMethod = el.cancelFullScreen||el.webkitCancelFullScreen||el.mozCancelFullScreen||el.exitFullscreen;
	if (requestMethod) { // cancel full screen.
		requestMethod.call(el);
	} else if (typeof window.ActiveXObject !== "undefined") { // Older IE.
		var wscript = new ActiveXObject("WScript.Shell");
		if (wscript !== null) {
			wscript.SendKeys("{F11}");
		}
	}
}

function blnIsIE() {
	return window.navigator.userAgent.indexOf("MSIE ") > 0;
}

function mapSearchBoxInitialize(idObject) {
	var objSearch = document.getElementById(idObject);
	var searchBox = new google.maps.places.SearchBox(objSearch);
	var searchBoxListener = google.maps.event.addListener(searchBox, 'places_changed', function() {
		if (mkTarget) { mkTarget.setMap(null); }
		var places = searchBox.getPlaces();
		if ((!places) || (places.length == 0)) return;
		var place = places[0];
		if (map) {
			var ptPlace = new google.maps.LatLng(place.geometry.location.lat(), place.geometry.location.lng());
			if ((blnIsFiltering) && (poly != null)) {
				poly.setCenter(ptPlace);
				map.fitBounds(poly.getBounds());
			} else {
				if (place.geometry.viewport) {
					map.fitBounds(place.geometry.viewport);
					if (poly) {
						poly.setBounds(place.geometry.viewport);
					}
				} else {
					map.panTo(place.geometry.location);
					map.setZoom(17);
					mapShowTargetMarker(place.geometry.location.lat(), place.geometry.location.lng());
				}
			}
		}
	});
}

function requestFullScreen(el) {
	// Supports most browsers and their versions.
	var requestMethod = el.requestFullScreen || el.webkitRequestFullScreen || el.mozRequestFullScreen || el.msRequestFullscreen;

	if (requestMethod) { // Native full screen.
		requestMethod.call(el);
	} else if (typeof window.ActiveXObject !== "undefined") { // Older IE.
		var wscript = new ActiveXObject("WScript.Shell");
		if (wscript !== null) {
			wscript.SendKeys("{F11}");
		}
	}
	return false
}

function mapCenterMyLocation() {
	// Try W3C Geolocation (Preferred)
	if(navigator.geolocation) {
		browserSupportFlag = true;
		navigator.geolocation.getCurrentPosition(function(position) {
			document.getElementById('strSearch').value = position.coords.latitude.toFixed(7) + ',' + position.coords.longitude.toFixed(7);
			map.setCenter(new google.maps.LatLng(position.coords.latitude,position.coords.longitude));
			mapShowTargetMarker(position.coords.latitude, position.coords.longitude);
		}, function() {
		  showInfoAlert("Your location could not be determined");
		});
	} else { // 
		showInfoAlert("Browser doesn't support Geolocation");
	}
}

function mapShowTargetMarker(dblLatitude, dblLongitude) {
	// Initializing Target Marker
	if (mkTarget != null) { mkTarget.setMap(null);}
	mkTarget = new google.maps.Marker({
		position: new google.maps.LatLng(dblLatitude, dblLongitude), draggable: false, zIndex:9999,
		icon: new google.maps.MarkerImage('img/target.png',null,null,null,new google.maps.Size(20, 20, 'px' , 'px')),
		clickable: true, visible: true, map: map
	});
	google.maps.event.addListener(mkTarget, "click", function(event) { mkTarget.setMap(null); });
}
	
function formatNumber(number) {
    number = number.toFixed(2) + '';
    x = number.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? ',' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + '.' + '$2');
    }
    return x1 + x2;
}

function arraySearch(arr, val) {
	for (var i=0; i<arr.length; i++) {
		if (arr[i] == val) {                    
			return i;
		} else {
			return false;
		}
	}
}

function numberWithThousands(x) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
}

function checkAllTable(blnChecked, idTable) {
	var table = document.getElementById(idTable);
	var tbody = table.getElementsByTagName("tbody")[0];
	var rows = tbody.getElementsByTagName("tr");
	for (var i=0;i<rows.length;i++) {
		var ck = rows[i].cells[0].firstChild;
		ck.checked = blnChecked;
	}
}

function strSerializeChecksTable(idTable) {
	var arrIds = [];
	var table = document.getElementById(idTable);
	var tbody = table.getElementsByTagName("tbody")[0];
	var rows = tbody.getElementsByTagName("tr");
	for (var i=0;i<rows.length;i++) {
		var ck = rows[i].cells[0].firstChild;
		if (! ck) continue;
		if (ck.checked) {
			arrIds.push(ck.value);
		}
	}
	var strIds = arrIds.join();
	return strIds;
}

function showSuccessAlert(strMessage, intSeconds) {
	var intMiliseconds = (intSeconds != null ? intSeconds*1000 : 1000);
	document.getElementById('alertSuccessMessage').innerHTML = (strMessage ? strMessage : document.getElementById('alertSuccess').title);
	document.getElementById('alertSuccess').style.top = parseInt($(window).scrollTop() + 10) + "px";
	$('#alertSuccess').fadeIn(intMiliseconds, function(){
		$('#alertSuccess').fadeOut(intMiliseconds, function(){});
	});

}

function showInfoAlert(strMessage, blnStay) {
	blnStay = blnStay ? blnStay : 3;
	//if (blnStay != 2) { $('#alertInfo').fadeOut()}
	document.getElementById('alertInfo').style.top = parseInt($(window).scrollTop() + 10) + "px";
	document.getElementById('alertInfoMessage').innerHTML = strMessage;
	if (blnStay == 1) {
		$('#alertInfo').fadeIn(500);
	} else if (blnStay == 2) {
		$('#alertInfo').fadeOut(500);
	} else {
		$('#alertInfo').fadeIn(1000, function(){
			$('#alertInfo').fadeOut(5000, function(){});
		});
	}
}

function br2nl(str) {
	str = replaceAll(str, '<br>', "\r\n");
	str = replaceAll(str, '<br />', "\r\n");
	str = replaceAll(str, '<br/>', "\r\n");
	str = replaceAll(str, '<BR>', "\r\n");
	str = replaceAll(str, '<BR />', "\r\n");
	str = replaceAll(str, '<BR/>', "\r\n");
	return str;
}

function scrollTopo(){ 
	$(document).scrollTop(-100000);
} 

function blnIsImage(strFileName){ 
	strFileName = strFileName.toLowerCase();
	if(!/[^/].(?:jpg|png|gif|bmp)/i.test(strFileName)){ 
		return false;
	} else{ 
		return true;
	} 
}

function strFormatAlias(str){ 
	str = replaceAll(str, ' ', '');
	str = str.toLowerCase();
	return str;
}

function showSession(arrSessions, intIndex){
	for (var i=0; i < arrSessions.length; i++) {
		var idObj = arrSessions[i];
		if (i == intIndex) {
			document.getElementById('menu_' + idObj).style.fontWeight = 'bold';
			document.getElementById('menu_' + idObj).style.backgroundColor = "#EEEEEE";
			document.getElementById('div_' + idObj).style.visibility = "visible";
			document.getElementById('div_' + idObj).style.display = "block";	
		} else {
			document.getElementById('menu_' + idObj).style.backgroundColor = "transparent";
			document.getElementById('menu_' + idObj).style.fontWeight = 'normal';
			document.getElementById('div_' + idObj).style.visibility = 'hidden';
			document.getElementById('div_' + idObj).style.display = "none";		
		}
	}
}

// Select combo based on value
function comboSelectByValue(obj, value) {
	for(var i=0; i<obj.options.length; i++) {
	  if (obj.options[i].value == value ) {
		obj.selectedIndex = i;
		break;
	  }
	}
}

function comboGetSelectedValues(obj) {
	var str = '';
	for (var i=0;i<obj.options.length;i++) {
		if (obj.options[i].selected == true){
			str += obj.options[i].value + ',';
		}
	}
	return str;
}

function comboMultipleSelectByValue(obj, strIds) {
	strIds = ',' + strIds + ',';
	for (var i=0;i<obj.options.length;i++) {
		if (strIds.indexOf(',' + obj.options[i].value + ',') >= 0) {
			obj.options[i].selected = true;
		} else {
			obj.options[i].selected = false;
		}
	}
}

function comboBuildSelect(obj, arrItems, idOptionNot) {
	// Clear items
	for (var i=obj.options.length-1;i>0;i--) {
		obj.options[i].remove(i);
	}
	for(var i=0; i<arrItems.length; i++) {
		if (arrItems[i]['idSiteSession'] == idOptionNot) continue;
		var option = document.createElement("option");
		option.value = arrItems[i]['idSiteSession'];
		option.text = arrItems[i]['strTitle'];
		obj.add(option);
	}
}

function comboClear(id) {
	var obj = document.getElementById(id);
	while (obj.options.length > 0) {
		obj.remove(0);
	}
}

// Return RGB random color
function getRandomColor() {
    var letters = '0123456789ABCDEF'.split('');
    var color = '#';
    for (var i = 0; i < 6; i++ ) {
        color += letters[Math.round(Math.random() * 15)];
    }
    return color; // '#FF0312'
}

function hexToR(h) {return parseInt((cutHex(h)).substring(0,2),16)}
function hexToG(h) {return parseInt((cutHex(h)).substring(2,4),16)}
function hexToB(h) {return parseInt((cutHex(h)).substring(4,6),16)}
function cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h}

function justNumbers(event){
	var tecla = window.event ? event.keyCode : event.which;
	var ctrlKey = event.ctrlKey;
	if (
		(tecla == 0) || // Arrows
		// Numbers
		(tecla > 47 && tecla < 58) || 
		 // Allow: home, end, left, right
		(tecla >= 35 && tecla <= 39) ||
		// Allow: backspace, delete, tab, escape, enter and .
		(tecla == 46) || (tecla == 8) || (tecla == 9) || (tecla == 27) || (tecla == 13) || (tecla == 110) || (tecla == 190) ||
		// Allow: Ctrl+Z or Ctrl+z
		((ctrlKey === true) && ((tecla == 90) || (tecla == 122))) ||
		// Allow: Ctrl+X or Ctrl+x
		((ctrlKey === true) && ((tecla == 88) || (tecla == 120))) ||
		// Allow: Ctrl+C or Ctrl+c
		((ctrlKey === true) && ((tecla == 67) || (tecla == 99))) ||
		 // Allow: Ctrl+V or Ctrl+v
		((ctrlKey === true) && ((tecla == 86) || (tecla == 118)))
	) {
		return true;
	}  else {
		return false;
    }
}

function strRemoveParentesis(str){
	str = replaceAll(str,'(','');
	str = replaceAll(str,')','');
	return str;
}

function replaceAll(string, token, newtoken) {
  //return string.replace(token,newtoken);
  //return string.replace(new RegExp(token, 'g'),newtoken);
  while (string.indexOf(token) != -1) {
    string = string.replace(token, newtoken);
  }
  return string;
}

function trim(str, chars) {
	return ltrim(rtrim(str, chars), chars);
}
 
function ltrim(str, chars) {
	chars = chars || "\\s";
	return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}
 
function rtrim(str, chars) {
	chars = chars || "\\s";
	return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}

function EliminateSpecialChars(strString) {
  //strString = replaceAll(strString,'#','');
  strCharCode = encodeURIComponent('#');
  strString = replaceAll(strString,'#',strCharCode);
  strCharCode = encodeURIComponent('+');
  strString = replaceAll(strString,'+',strCharCode);
  strString = replaceAll(strString,'"','');
  strString = replaceAll(strString,"'",'');
  return strString;
}

function strChangeHash(strString) {
  strCharCode = encodeURIComponent('#');
  strString = replaceAll(strString,'#', '');
  //strString = replaceAll(strString,'"', '');
  return strString;
}

function strChangeE(strString) {
  strCharCode = encodeURIComponent('&');
  strString = replaceAll(strString,'&', strCharCode);
  //strString = replaceAll(strString,'"', '');
  return strString;
}

function inputOnlyNumber(e){
    var tecla=(window.event)?event.keyCode:e.which;
  if((tecla > 47 && tecla < 58) || (tecla == 46) || (tecla == 45)) return true;
    else{
    if (tecla != 8) return false;
    else return true;
    }
}

function addCommas(nStr) {
	nStr += '';
	x = nStr.split(',');
	x1 = x[0];
	x2 = x.length > 1 ? ',' + x[1] : '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + '.' + '$2');
	}
	return x1 + x2;
}

function strCoordinatesFormat(strCoordinates) {
	var vfim
	var temp
	var sinal = ""
	strCoordinates = trim(strCoordinates);
	
	if (strCoordinates.substr(0,1) == "-") {
		sinal = "-"
		strCoordinates = strCoordinates.substr(1,strCoordinates.length)
	}
	// Decimal Format - DD.MMSSSS
	if (strCoordinates.search(' ') < 0) {	 
		vfim = strCoordinates
	} else if (strCoordinates.search(' ') >= 0) {
		// Decimal Second  - DD MM SS.SSS
		if (strCoordinates.substr(strCoordinates.search(' ')+1, strCoordinates.length).search(' ') >= 0) {
			temp = strCoordinates
			graus = trim(temp.substr(0,temp.search(' ')))
			temp = temp.substr(temp.search(' ')+1,temp.length)
			minutos = trim(temp.substr(0,temp.search(' ')))
			temp = temp.substr(temp.search(' ')+1,temp.length)
			segundos = trim(temp)
			vfim = eval(graus) + eval(minutos/60) + eval(segundos/3600)
		// Decimal Minute Format - DD MM.SSSSS
		} else {
			temp = strCoordinates
			graus = trim(temp.substr(0,temp.search(' ')))
			temp = temp.substr(temp.search(' ')+1,temp.length)
			minutos = trim(temp)
			vfim = eval(graus) + eval(minutos/60)
		}
	}
	strCoordinates = sinal + vfim;
	return strCoordinates;
}