SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;

SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;

SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';





-- -----------------------------------------------------

-- Table `country`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `country` ;



CREATE  TABLE IF NOT EXISTS `country` (

  `idCountry` INT NOT NULL AUTO_INCREMENT ,

  `strName` VARCHAR(50) NULL ,

  `strCapital` VARCHAR(50) BINARY NULL ,

  `strTelAreaCode` VARCHAR(5) NULL ,

  `strCurrencySymbol` VARCHAR(20) NULL ,

  `strLanguageCode` VARCHAR(8) NULL ,

  PRIMARY KEY (`idCountry`) )

ENGINE = InnoDB;



REPLACE INTO `country` (`strName`, `strCapital`, `strTelAreaCode`, `strCurrencySymbol`, `strLanguageCode`) VALUES 

	('Afghanistan','Kabul','93','AFN','af'),

	('Albania','Tirana','355','ALL','al'),

	('Algeria','Algiers','213','DZD','dz'),

	('American Samoa','Pago Pago','684','USD','as'),

	('Andorra','Andorra','376','EUR','ad'),

	('Angola','Luanda','244','AOA','ao'),

	('Anguilla','The Valley','1-264','XCD','ai'),

	('Antarctica','None','672','XCD','aq'),

	('Antigua and Barbuda','St. Johns','1-268','XCD','ag'),

	('Argentina','Buenos Aires','54','ARS','ar'),

	('Armenia','Yerevan','374','AMD','am'),

	('Aruba','Oranjestad','297','AWG','aw'),

	('Australia','Canberra','61','AUD','au'),

	('Austria','Vienna','43','EUR','at'),

	('Azerbaijan','Baku','994','AZN','az'),

	('Bahamas','Nassau','1-242','BSD','bs'),

	('Bahrain','Al-Manamah','973','BHD','bh'),

	('Bangladesh','Dhaka','880','BDT','bd'),

	('Barbados','Bridgetown','1-246','BBD','bb'),

	('Belarus','Minsk','375','BYR','by'),

	('Belgium','Brussels','32','EUR','be'),

	('Belize','Belmopan','501','BZD','bz'),

	('Benin','Porto-Novo','229','XOF','bj'),

	('Bermuda','Hamilton','1-441','BMD','bm'),

	('Bhutan','Thimphu','975','BTN','bt'),

	('Bolivia','La Paz','591','BOB','bo'),

	('Bosnia-Herzegovina','Sarajevo','387','BAM','ba'),

	('Botswana','Gaborone','267','BWP','bw'),

	('Bouvet Island','None','','NOK','bv'),

	('Brazil','Brasilia','55','BRL','br'),

	('British Indian Ocean Territory','None','','USD','io'),

	('Brunei Darussalam','Bandar Seri Begawan','673','BND','bn'),

	('Bulgaria','Sofia','359','BGN','bg'),

	('Burkina Faso','Ouagadougou','226','XOF','bf'),

	('Burundi','Bujumbura','257','BIF','bi'),

	('Cambodia','Phnom Penh','855','KHR','kh'),

	('Cameroon','Yaounde','237','XAF','cm'),

	('Canada','Ottawa','1','CAD','ca'),

	('Cape Verde','Praia','238','CVE','cv'),

	('Cayman Islands','Georgetown','1-345','KYD','ky'),

	('Central African Republic','Bangui','236','XAF','cf'),

	('Chad','N\'Djamena','235','XAF','td'),

	('Chile','Santiago','56','CLP','cl'),

	('China','Beijing','86','CNY','cn'),

	('Christmas Island','The Settlement','61','AUD','cx'),

	('Cocos (Keeling) Islands','West Island','61','AUD','cc'),

	('Colombia','Bogota','57','COP','co'),

	('Comoros','Moroni','269','KMF','km'),

	('Congo','Brazzaville','242','XAF','cg'),

	('Congo, Dem. Republic','Kinshasa','243','CDF','cd'),

	('Cook Islands','Avarua','682','NZD','ck'),

	('Costa Rica','San Jose','506','CRC','cr'),

	('Croatia','Zagreb','385','HRK','hr'),

	('Cuba','Havana','53','CUP','cu'),

	('Cyprus','Nicosia','357','EUR','cy'),

	('Czech Rep.','Prague','420','CZK','cz'),

	('Denmark','Copenhagen','45','DKK','dk'),

	('Djibouti','Djibouti','253','DJF','dj'),

	('Dominica','Roseau','1-767','XCD','dm'),

	('Dominican Republic','Santo Domingo','809','DOP','do'),

	('Ecuador','Quito','593','ECS','ec'),

	('Egypt','Cairo','20','EGP','eg'),

	('El Salvador','San Salvador','503','SVC','sv'),

	('Equatorial Guinea','Malabo','240','XAF','gq'),

	('Eritrea','Asmara','291','ERN','er'),

	('Estonia','Tallinn','372','EUR','ee'),

	('Ethiopia','Addis Ababa','251','ETB','et'),

	('European Union','Brussels','','EUR','eu.int'),

	('Falkland Islands (Malvinas)','Stanley','500','FKP','fk'),

	('Faroe Islands','Torshavn','298','DKK','fo'),

	('Fiji','Suva','679','FJD','fj'),

	('Finland','Helsinki','358','EUR','fi'),

	('France','Paris','33','EUR','fr'),

	('French Guiana','Cayenne','594','EUR','gf'),

	('French Southern Territories','None','','EUR','tf'),

	('Gabon','Libreville','241','XAF','ga'),

	('Gambia','Banjul','220','GMD','gm'),

	('Georgia','Tbilisi','995','GEL','ge'),

	('Germany','Berlin','49','EUR','de'),

	('Ghana','Accra','233','GHS','gh'),

	('Gibraltar','Gibraltar','350','GIP','gi'),

	('Great Britain','London','44','GBP','gb'),

	('Greece','Athens','30','EUR','gr'),

	('Greenland','Godthab','299','DKK','gl'),

	('Grenada','St. George\'s','1-473','XCD','gd'),

	('Guadeloupe (French)','Basse-Terre','590','EUR','gp'),

	('Guam (USA)','Agana','1-671','USD','gu'),

	('Guatemala','Guatemala City','502','QTQ','gt'),

	('Guernsey','St. Peter Port','','GGP','gg'),

	('Guinea','Conakry','224','GNF','gn'),

	('Guinea Bissau','Bissau','245','GWP','gw'),

	('Guyana','Georgetown','592','GYD','gy'),

	('Haiti','Port-au-Prince','509','HTG','ht'),

	('Heard Island and McDonald Islands','None','','AUD','hm'),

	('Honduras','Tegucigalpa','504','HNL','hn'),

	('Hong Kong','Victoria','852','HKD','hk'),

	('Hungary','Budapest','36','HUF','hu'),

	('Iceland','Reykjavik','354','ISK','is'),

	('India','New Delhi','91','INR','in'),

	('Indonesia','Jakarta','62','IDR','id'),

	('Iran','Tehran','98','IRR','ir'),

	('Iraq','Baghdad','964','IQD','iq'),

	('Ireland','Dublin','353','EUR','ie'),

	('Isle of Man','Douglas','','GBP','im'),

	('Israel','Jerusalem','972','ILS','il'),

	('Italy','Rome','39','EUR','it'),

	('Ivory Coast','Abidjan','225','XOF','ci'),

	('Jamaica','Kingston','1-876','JMD','jm'),

	('Japan','Tokyo','81','JPY','jp'),

	('Jersey','Saint Helier','','GBP','je'),

	('Jordan','Amman','962','JOD','jo'),

	('Kazakhstan','Astana','7','KZT','kz'),

	('Kenya','Nairobi','254','KES','ke'),

	('Kiribati','Tarawa','686','AUD','ki'),

	('Korea-North','Pyongyang','850','KPW','kp'),

	('Korea-South','Seoul','82','KRW','kr'),

	('Kuwait','Kuwait City','965','KWD','kw'),

	('Kyrgyzstan','Bishkek','996','KGS','kg'),

	('Laos','Vientiane','856','LAK','la'),

	('Latvia','Riga','371','LVL','lv'),

	('Lebanon','Beirut','961','LBP','lb'),

	('Lesotho','Maseru','266','LSL','ls'),

	('Liberia','Monrovia','231','LRD','lr'),

	('Libya','Tripoli','218','LYD','ly'),

	('Liechtenstein','Vaduz','423','CHF','li'),

	('Lithuania','Vilnius','370','LTL','lt'),

	('Luxembourg','Luxembourg','352','EUR','lu'),

	('Macau','Macau','853','MOP','mo'),

	('Macedonia','Skopje','389','MKD','mk'),

	('Madagascar','Antananarivo','261','MGF','mg'),

	('Malawi','Lilongwe','265','MWK','mw'),

	('Malaysia','Kuala Lumpur','60','MYR','my'),

	('Maldives','Male','960','MVR','mv'),

	('Mali','Bamako','223','XOF','ml'),

	('Malta','Valletta','356','EUR','mt'),

	('Marshall Islands','Majuro','692','USD','mh'),

	('Martinique (French)','Fort-de-France','596','EUR','mq'),

	('Mauritania','Nouakchott','222','MRO','mr'),

	('Mauritius','Port Louis','230','MUR','mu'),

	('Mayotte','Dzaoudzi','269','EUR','yt'),

	('Mexico','Mexico City','52','MXN','mx'),

	('Micronesia','Palikir','691','USD','fm'),

	('Moldova','Kishinev','373','MDL','md'),

	('Monaco','Monaco','377','EUR','mc'),

	('Mongolia','Ulan Bator','976','MNT','mn'),

	('Montenegro','Podgorica','382','EUR','me'),

	('Montserrat','Plymouth','1-664','XCD','ms'),

	('Morocco','Rabat','212','MAD','ma'),

	('Mozambique','Maputo','258','MZN','mz'),

	('Myanmar','Naypyidaw','95','MMK','mm'),

	('Namibia','Windhoek','264','NAD','na'),

	('Nauru','Yaren','674','AUD','nr'),

	('Nepal','Kathmandu','977','NPR','np'),

	('Netherlands','Amsterdam','31','EUR','nl'),

	('Netherlands Antilles','Willemstad','599','ANG','an'),

	('New Caledonia (French)','Noumea','687','XPF','nc'),

	('New Zealand','Wellington','64','NZD','nz'),

	('Nicaragua','Managua','505','NIO','ni'),

	('Niger','Niamey','227','XOF','ne'),

	('Nigeria','Lagos','234','NGN','ng'),

	('Niue','Alofi','683','NZD','nu'),

	('Norfolk Island','Kingston','672','AUD','nf'),

	('Northern Mariana Islands','Saipan','670','USD','mp'),

	('Norway','Oslo','47','NOK','no'),

	('Oman','Muscat','968','OMR','om'),

	('Pakistan','Islamabad','92','PKR','pk'),

	('Palau','Koror','680','USD','pw'),

	('Panama','Panama City','507','PAB','pa'),

	('Papua New Guinea','Port Moresby','675','PGK','pg'),

	('Paraguay','Asuncion','595','PYG','py'),

	('Peru','Lima','51','PEN','pe'),

	('Philippines','Manila','63','PHP','ph'),

	('Pitcairn Island','Adamstown','','NZD','pn'),

	('Poland','Warsaw','48','PLN','pl'),

	('Polynesia (French)','Papeete','689','XPF','pf'),

	('Portugal','Lisbon','351','EUR','pt'),

	('Puerto Rico','San Juan','1-787','USD','pr'),

	('Qatar','Doha','974','QAR','qa'),

	('Reunion (French)','Saint-Denis','262','EUR','re'),

	('Romania','Bucharest','40','RON','ro'),

	('Russia','Moscow','7','RUB','ru'),

	('Rwanda','Kigali','250','RWF','rw'),

	('Saint Helena','Jamestown','290','SHP','sh'),

	('Saint Kitts & Nevis Anguilla','Basseterre','1-869','XCD','kn'),

	('Saint Lucia','Castries','1-758','XCD','lc'),

	('Saint Pierre and Miquelon','St. Pierre','508','EUR','pm'),

	('Saint Vincent & Grenadines','Kingstown','1-784','XCD','vc'),

	('Samoa','Apia','684','WST','ws'),

	('San Marino','San Marino','378','EUR','sm'),

	('Sao Tome and Principe','Sao Tome','239','STD','st'),

	('Saudi Arabia','Riyadh','966','SAR','sa'),

	('Senegal','Dakar','221','XOF','sn'),

	('Serbia','Belgrade','381','RSD','rs'),

	('Seychelles','Victoria','248','SCR','sc'),

	('Sierra Leone','Freetown','232','SLL','sl'),

	('Singapore','Singapore','65','SGD','sg'),

	('Slovakia','Bratislava','421','EUR','sk'),

	('Slovenia','Ljubljana','386','EUR','si'),

	('Solomon Islands','Honiara','677','SBD','sb'),

	('Somalia','Mogadishu','252','SOS','so'),

	('South Africa','Pretoria','27','ZAR','za'),

	('South Georgia & South Sandwich Islands','None','','GBP','gs'),

	('South Sudan','Ramciel','','SSP','ss'),

	('Spain','Madrid','34','EUR','es'),

	('Sri Lanka','Colombo','94','LKR','lk'),

	('Sudan','Khartoum','249','SDG','sd'),

	('Suriname','Paramaribo','597','SRD','sr'),

	('Svalbard and Jan Mayen Islands','Longyearbyen','','NOK','sj'),

	('Swaziland','Mbabane','268','SZL','sz'),

	('Sweden','Stockholm','46','SEK','se'),

	('Switzerland','Bern','41','CHF','ch'),

	('Syria','Damascus','963','SYP','sy'),

	('Taiwan','Taipei','886','TWD','tw'),

	('Tajikistan','Dushanbe','992','TJS','tj'),

	('Tanzania','Dodoma','255','TZS','tz'),

	('Thailand','Bangkok','66','THB','th'),

	('Togo','Lome','228','XOF','tg'),

	('Tokelau','None','690','NZD','tk'),

	('Tonga','Nuku\'alofa','676','TOP','to'),

	('Trinidad and Tobago','Port of Spain','1-868','TTD','tt'),

	('Tunisia','Tunis','216','TND','tn'),

	('Turkey','Ankara','90','TRY','tr'),

	('Turkmenistan','Ashgabat','993','TMT','tm'),

	('Turks and Caicos Islands','Grand Turk','1-649','USD','tc'),

	('Tuvalu','Funafuti','688','AUD','tv'),

	('U.K.','London','44','GBP','uk'),

	('Uganda','Kampala','256','UGX','ug'),

	('Ukraine','Kiev','380','UAH','ua'),

	('United Arab Emirates','Abu Dhabi','971','AED','ae'),

	('Uruguay','Montevideo','598','UYU','uy'),

	('USA','Washington','1','USD','us'),

	('USA Minor Outlying Islands','None','','USD','um'),

	('Uzbekistan','Tashkent','998','UZS','uz'),

	('Vanuatu','Port Vila','678','VUV','vu'),

	('Vatican','Vatican City','39','EUR','va'),

	('Venezuela','Caracas','58','VEF','ve'),

	('Vietnam','Hanoi','84','VND','vn'),

	('Virgin Islands (British)','Road Town','1-284','USD','vg'),

	('Virgin Islands (USA)','Charlotte Amalie','1-340','USD','vi'),

	('Wallis and Futuna Islands','Mata-Utu','681','XPF','wf'),

	('Western Sahara','El Aaiun','','MAD','eh'),

	('Yemen','San\'a','967','YER','ye'),

	('Zambia','Lusaka','260','ZMW','zm'),

	('Zimbabwe','Harare','263','ZWD','zw');





-- -----------------------------------------------------

-- Table `projectuserscope`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `projectuserscope` ;



CREATE  TABLE IF NOT EXISTS `projectuserscope` (

  `idProjectUserScope` INT NOT NULL AUTO_INCREMENT ,

  `strProjectUserScope` VARCHAR(50) NULL ,

  PRIMARY KEY (`idProjectUserScope`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `csstheme`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `csstheme` ;



CREATE  TABLE IF NOT EXISTS `csstheme` (

  `idCSSTheme` INT NOT NULL AUTO_INCREMENT ,

  `strThemeName` VARCHAR(100) NULL ,

  PRIMARY KEY (`idCSSTheme`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `project`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `project` ;



CREATE  TABLE IF NOT EXISTS `project` (

  `idProject` INT NOT NULL AUTO_INCREMENT ,

  `idUserCreator` INT NULL ,

  `blnActive` TINYINT(1) NOT NULL DEFAULT 1 ,

  `dtDateCreation` DATETIME NULL ,

  `strAlias` VARCHAR(45) NULL ,

  `strName` VARCHAR(255) NULL ,

  `txtDescription` TEXT NULL ,

  `strAddress` VARCHAR(244) NULL ,

  `dblLatitude` FLOAT NULL ,

  `dblLongitude` FLOAT NULL ,

  `idCountry` INT NOT NULL DEFAULT 30 ,

  `strSiteURL` VARCHAR(255) NULL ,

  `strRGBColor` VARCHAR(10) NULL ,

  `strGoogleAnalyticsID` VARCHAR(50) NULL ,

  `strSkypeID` VARCHAR(50) NULL ,

  `idCSSTheme` INT NOT NULL DEFAULT 1 ,

  `strLogoFile` VARCHAR(20) NULL ,

  `strBackgroundFile` VARCHAR(20) NULL ,

  `blnAllowAllView` TINYINT(1) NOT NULL DEFAULT 0 ,

  `blnAllowJoin` TINYINT(1) NOT NULL DEFAULT 1 ,

  `blnAllowJoinAsLevel3` TINYINT(1) NOT NULL DEFAULT 0 ,

  `idProjectUserViewScope` INT NOT NULL DEFAULT 1 ,

  `idProjectUserEditScope` INT NOT NULL DEFAULT 1 ,

  PRIMARY KEY (`idProject`) ,

  INDEX `fk_attraction_country1_idx` (`idCountry` ASC) ,

  INDEX `fk_project_projectuserviewscope1_idx` (`idProjectUserViewScope` ASC) ,

  INDEX `fk_project_csstheme1_idx` (`idCSSTheme` ASC) ,

  INDEX `fk_project_projectuserviewscope2_idx` (`idProjectUserEditScope` ASC) ,

  CONSTRAINT `fk_attraction_country1`

    FOREIGN KEY (`idCountry` )

    REFERENCES `country` (`idCountry` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_project_projectuserviewscope1`

    FOREIGN KEY (`idProjectUserViewScope` )

    REFERENCES `projectuserscope` (`idProjectUserScope` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_project_csstheme1`

    FOREIGN KEY (`idCSSTheme` )

    REFERENCES `csstheme` (`idCSSTheme` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_project_projectuserviewscope2`

    FOREIGN KEY (`idProjectUserEditScope` )

    REFERENCES `projectuserscope` (`idProjectUserScope` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userlevel`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userlevel` ;



CREATE  TABLE IF NOT EXISTS `userlevel` (

  `idUserLevel` INT NOT NULL AUTO_INCREMENT ,

  `strLevel` VARCHAR(45) NULL ,

  PRIMARY KEY (`idUserLevel`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `user`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `user` ;



CREATE  TABLE IF NOT EXISTS `user` (

  `idUser` INT NOT NULL AUTO_INCREMENT ,

  `idProject` INT NOT NULL ,

  `idUserLevel` INT NOT NULL DEFAULT 1 ,

  `blnDeleted` TINYINT(1) NOT NULL DEFAULT 0 ,

  `blnActive` TINYINT(1) NOT NULL DEFAULT 1 ,

  `dtRegister` DATETIME NULL ,

  `strName` VARCHAR(100) NULL ,

  `strEmail` VARCHAR(100) NULL ,

  `strPassword` VARCHAR(45) NULL ,

  `dblLatitude` DOUBLE NULL ,

  `dblLongitude` DOUBLE NULL ,

  `strProfilePhotoPath` VARCHAR(45) NULL ,

  `strSkypeID` VARCHAR(50) NULL ,

  `user_idUser` INT NOT NULL ,

  PRIMARY KEY (`idUser`) ,

  INDEX `fk_user_project1_idx` (`idProject` ASC) ,

  INDEX `fk_user_userlevel1_idx` (`idUserLevel` ASC) ,

  INDEX `fk_user_user1_idx` (`user_idUser` ASC) ,

  CONSTRAINT `fk_user_project1`

    FOREIGN KEY (`idProject` )

    REFERENCES `project` (`idProject` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_user_userlevel1`

    FOREIGN KEY (`idUserLevel` )

    REFERENCES `userlevel` (`idUserLevel` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_user_user1`

    FOREIGN KEY (`user_idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `support`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `support` ;



CREATE  TABLE IF NOT EXISTS `support` (

  `idSupport` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `dtDateTime` DATETIME NULL ,

  `strSubject` VARCHAR(200) NULL ,

  `txtMessage` TEXT NULL ,

  `strFileName` VARCHAR(100) NULL ,

  PRIMARY KEY (`idSupport`) ,

  INDEX `fk_support_exhibitor1_idx` (`idUser` ASC) ,

  CONSTRAINT `fk_support_exhibitor1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `supportresponse`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `supportresponse` ;



CREATE  TABLE IF NOT EXISTS `supportresponse` (

  `idSupportResponse` INT NOT NULL AUTO_INCREMENT ,

  `idSupport` INT NOT NULL ,

  `dtDateTime` DATETIME NULL ,

  `txtMessage` TEXT NULL ,

  `blnFromSupport` TINYINT(1) NOT NULL DEFAULT 0 ,

  `blnRead` TINYINT(1) NOT NULL DEFAULT 0 ,

  PRIMARY KEY (`idSupportResponse`) ,

  INDEX `fk_supportresponse_support1_idx` (`idSupport` ASC) ,

  CONSTRAINT `fk_supportresponse_support1`

    FOREIGN KEY (`idSupport` )

    REFERENCES `support` (`idSupport` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `datum`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `datum` ;



CREATE  TABLE IF NOT EXISTS `datum` (

  `idDatum` INT NOT NULL AUTO_INCREMENT ,

  `strName` VARCHAR(100) NULL ,

  `dblA` DOUBLE NULL ,

  `dblE2` DOUBLE NULL ,

  PRIMARY KEY (`idDatum`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `projectworkgroup`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `projectworkgroup` ;



CREATE  TABLE IF NOT EXISTS `projectworkgroup` (

  `idProjectWorkgroup` INT NULL AUTO_INCREMENT ,

  `idProject` INT NOT NULL ,

  `strWorkgroup` VARCHAR(100) NULL ,

  PRIMARY KEY (`idProjectWorkgroup`) ,

  INDEX `fk_projectusergroup_project1_idx` (`idProject` ASC) ,

  CONSTRAINT `fk_projectusergroup_project1`

    FOREIGN KEY (`idProject` )

    REFERENCES `project` (`idProject` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `eventtype`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `eventtype` ;



CREATE  TABLE IF NOT EXISTS `eventtype` (

  `idEventType` INT NOT NULL AUTO_INCREMENT ,

  `strEventType` VARCHAR(45) NULL ,

  PRIMARY KEY (`idEventType`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `event`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `event` ;



CREATE  TABLE IF NOT EXISTS `event` (

  `idEvent` INT NOT NULL AUTO_INCREMENT ,

  `idEventType` INT NOT NULL ,

  `idUser` INT NULL ,

  `dtDateTime` DATETIME NULL ,

  `strParam1` VARCHAR(100) NULL ,

  `strParam2` VARCHAR(100) NULL ,

  `strParam3` VARCHAR(100) NULL ,

  PRIMARY KEY (`idEvent`) ,

  INDEX `fk_usereventlog_usereventtype1_idx` (`idEventType` ASC) ,

  CONSTRAINT `fk_usereventlog_usereventtype1`

    FOREIGN KEY (`idEventType` )

    REFERENCES `eventtype` (`idEventType` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `marker`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `marker` ;



CREATE  TABLE IF NOT EXISTS `marker` (

  `idMarker` INT NOT NULL AUTO_INCREMENT ,

  `strMarkerFileName` VARCHAR(45) NULL ,

  `idProject` INT NULL ,

  PRIMARY KEY (`idMarker`) ,

  INDEX `fk_marker_project1_idx` (`idProject` ASC) ,

  CONSTRAINT `fk_marker_project1`

    FOREIGN KEY (`idProject` )

    REFERENCES `project` (`idProject` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `form`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `form` ;



CREATE  TABLE IF NOT EXISTS `form` (

  `idForm` INT NOT NULL AUTO_INCREMENT ,

  `idProject` INT NOT NULL ,

  `idMarker` INT NOT NULL ,

  `dtCreation` DATETIME NULL ,

  `dtLastUpdate` DATETIME NULL ,

  `strName` VARCHAR(100) NULL ,

  `blnActive` TINYINT(1) NOT NULL DEFAULT 1 ,

  PRIMARY KEY (`idForm`) ,

  INDEX `fk_form_project1_idx` (`idProject` ASC) ,

  INDEX `fk_form_marker1_idx` (`idMarker` ASC) ,

  CONSTRAINT `fk_form_project1`

    FOREIGN KEY (`idProject` )

    REFERENCES `project` (`idProject` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_form_marker1`

    FOREIGN KEY (`idMarker` )

    REFERENCES `marker` (`idMarker` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formfieldtype`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formfieldtype` ;



CREATE  TABLE IF NOT EXISTS `formfieldtype` (

  `idFormFieldType` INT NOT NULL AUTO_INCREMENT ,

  `strFormFieldType` VARCHAR(45) NULL ,

  PRIMARY KEY (`idFormFieldType`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formfield`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formfield` ;



CREATE  TABLE IF NOT EXISTS `formfield` (

  `idFormField` INT NOT NULL AUTO_INCREMENT ,

  `idForm` INT NOT NULL ,

  `idFormFieldType` INT NOT NULL ,

  `strName` VARCHAR(255) NULL ,

  `strTip` VARCHAR(255) NULL ,

  `intOrder` INT NULL ,

  `blnActive` TINYINT(1) NULL ,

  PRIMARY KEY (`idFormField`) ,

  INDEX `fk_formfield_form1_idx` (`idForm` ASC) ,

  INDEX `fk_formfield_formfieldtype1_idx` (`idFormFieldType` ASC) ,

  CONSTRAINT `fk_formfield_form1`

    FOREIGN KEY (`idForm` )

    REFERENCES `form` (`idForm` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formfield_formfieldtype1`

    FOREIGN KEY (`idFormFieldType` )

    REFERENCES `formfieldtype` (`idFormFieldType` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `device`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `device` ;



CREATE  TABLE IF NOT EXISTS `device` (

  `idDevice` INT NOT NULL AUTO_INCREMENT ,

  `strName` VARCHAR(45) NULL ,

  PRIMARY KEY (`idDevice`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `shapetype`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `shapetype` ;



CREATE  TABLE IF NOT EXISTS `shapetype` (

  `idShapeType` INT NOT NULL AUTO_INCREMENT ,

  `strShapeType` VARCHAR(45) NULL ,

  PRIMARY KEY (`idShapeType`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecord`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecord` ;



CREATE  TABLE IF NOT EXISTS `formrecord` (

  `idFormRecord` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `idForm` INT NOT NULL ,

  `idDevice` INT NOT NULL DEFAULT 1 ,

  `idShapeType` INT NOT NULL ,

  `strCustomMarkerRGBColor` VARCHAR(255) NULL ,

  `dtCreation` DATETIME NULL ,

  `dtLastUpdate` DATETIME NULL ,

  PRIMARY KEY (`idFormRecord`) ,

  INDEX `fk_formrecord_user1_idx` (`idUser` ASC) ,

  INDEX `fk_formrecord_form1_idx` (`idForm` ASC) ,

  INDEX `fk_formrecord_device1_idx` (`idDevice` ASC) ,

  INDEX `fk_formrecord_shapetype1_idx` (`idShapeType` ASC) ,

  CONSTRAINT `fk_formrecord_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formrecord_form1`

    FOREIGN KEY (`idForm` )

    REFERENCES `form` (`idForm` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formrecord_device1`

    FOREIGN KEY (`idDevice` )

    REFERENCES `device` (`idDevice` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formrecord_shapetype1`

    FOREIGN KEY (`idShapeType` )

    REFERENCES `shapetype` (`idShapeType` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userapisession`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userapisession` ;



CREATE  TABLE IF NOT EXISTS `userapisession` (

  `idUserAPISession` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `dtDate` DATETIME NULL ,

  `strKey` VARCHAR(45) NULL ,

  PRIMARY KEY (`idUserAPISession`) ,

  INDEX `fk_APISession_user1_idx` (`idUser` ASC) ,

  CONSTRAINT `fk_APISession_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userposition`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userposition` ;



CREATE  TABLE IF NOT EXISTS `userposition` (

  `idUserPosition` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `dtDate` DATETIME NULL ,

  `dblLatitude` DOUBLE NULL ,

  `dblLongitude` DOUBLE NULL ,

  PRIMARY KEY (`idUserPosition`) ,

  INDEX `fk_userposition_user1_idx` (`idUser` ASC) ,

  CONSTRAINT `fk_userposition_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordvertex`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordvertex` ;



CREATE  TABLE IF NOT EXISTS `formrecordvertex` (

  `idFormRecordVertex` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecord` INT NOT NULL ,

  `dblLatitude` DOUBLE NULL ,

  `dblLongitude` DOUBLE NULL ,

  `intPosition` INT NULL ,

  PRIMARY KEY (`idFormRecordVertex`) ,

  INDEX `fk_formrecordvertex_formrecord1_idx` (`idFormRecord` ASC) ,

  CONSTRAINT `fk_formrecordvertex_formrecord1`

    FOREIGN KEY (`idFormRecord` )

    REFERENCES `formrecord` (`idFormRecord` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfield`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfield` ;



CREATE  TABLE IF NOT EXISTS `formrecordfield` (

  `idFormRecordField` INT NOT NULL AUTO_INCREMENT ,

  `idFormField` INT NOT NULL ,

  `idFormRecord` INT NOT NULL ,

  PRIMARY KEY (`idFormRecordField`) ,

  INDEX `fk_formrecordfield_formfield1_idx` (`idFormField` ASC) ,

  INDEX `fk_formrecordfield_formrecord1_idx` (`idFormRecord` ASC) ,

  CONSTRAINT `fk_formrecordfield_formfield1`

    FOREIGN KEY (`idFormField` )

    REFERENCES `formfield` (`idFormField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formrecordfield_formrecord1`

    FOREIGN KEY (`idFormRecord` )

    REFERENCES `formrecord` (`idFormRecord` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfieldtext`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfieldtext` ;



CREATE  TABLE IF NOT EXISTS `formrecordfieldtext` (

  `idText` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecordField` INT NOT NULL ,

  `strValue` TEXT NULL ,

  PRIMARY KEY (`idText`) ,

  INDEX `fk_formrecordfieldtext_formrecordfield1_idx` (`idFormRecordField` ASC) ,

  CONSTRAINT `fk_formrecordfieldtext_formrecordfield1`

    FOREIGN KEY (`idFormRecordField` )

    REFERENCES `formrecordfield` (`idFormRecordField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfieldnumeric`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfieldnumeric` ;



CREATE  TABLE IF NOT EXISTS `formrecordfieldnumeric` (

  `idNumeric` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecordField` INT NOT NULL ,

  `dblValue` DOUBLE NULL ,

  PRIMARY KEY (`idNumeric`) ,

  INDEX `fk_formrecordfieldtext_formrecordfield1_idx` (`idFormRecordField` ASC) ,

  CONSTRAINT `fk_formrecordfieldtext_formrecordfield10`

    FOREIGN KEY (`idFormRecordField` )

    REFERENCES `formrecordfield` (`idFormRecordField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formfieldalternative`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formfieldalternative` ;



CREATE  TABLE IF NOT EXISTS `formfieldalternative` (

  `idFormFieldAlternative` INT NOT NULL AUTO_INCREMENT ,

  `idFormField` INT NOT NULL ,

  `strAlternative` VARCHAR(45) NULL ,

  `blnPublic` TINYINT(1) NOT NULL DEFAULT 1 ,

  PRIMARY KEY (`idFormFieldAlternative`) ,

  INDEX `fk_formfieldalternative_formfield1_idx` (`idFormField` ASC) ,

  CONSTRAINT `fk_formfieldalternative_formfield1`

    FOREIGN KEY (`idFormField` )

    REFERENCES `formfield` (`idFormField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfieldalternative`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfieldalternative` ;



CREATE  TABLE IF NOT EXISTS `formrecordfieldalternative` (

  `idFormRecordFieldAlternative` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecordField` INT NOT NULL ,

  `idFormFieldAlternative` INT NOT NULL ,

  PRIMARY KEY (`idFormRecordFieldAlternative`) ,

  INDEX `fk_formrecordfieldtext_formrecordfield1_idx` (`idFormRecordField` ASC) ,

  INDEX `fk_formrecordfieldmultiplechoice_formfieldalternative1_idx` (`idFormFieldAlternative` ASC) ,

  CONSTRAINT `fk_formrecordfieldtext_formrecordfield100`

    FOREIGN KEY (`idFormRecordField` )

    REFERENCES `formrecordfield` (`idFormRecordField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formrecordfieldmultiplechoice_formfieldalternative1`

    FOREIGN KEY (`idFormFieldAlternative` )

    REFERENCES `formfieldalternative` (`idFormFieldAlternative` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfile`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfile` ;



CREATE  TABLE IF NOT EXISTS `formrecordfile` (

  `idFormRecordFile` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecord` INT NULL ,

  `strFileName` VARCHAR(255) NULL ,

  `strFileOriginalName` VARCHAR(255) NULL ,

  `strDescription` VARCHAR(255) NULL ,

  `intPosition` INT NULL ,

  PRIMARY KEY (`idFormRecordFile`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfielddate`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfielddate` ;



CREATE  TABLE IF NOT EXISTS `formrecordfielddate` (

  `idFormRecordFieldDate` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecordField` INT NOT NULL ,

  `dtValue` DATE NULL ,

  PRIMARY KEY (`idFormRecordFieldDate`) ,

  INDEX `fk_formrecordfielddatetime_formrecordfield1_idx` (`idFormRecordField` ASC) ,

  CONSTRAINT `fk_formrecordfielddatetime_formrecordfield1`

    FOREIGN KEY (`idFormRecordField` )

    REFERENCES `formrecordfield` (`idFormRecordField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `projectsearch`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `projectsearch` ;



CREATE  TABLE IF NOT EXISTS `projectsearch` (

  `idProjectSearch` INT NOT NULL AUTO_INCREMENT ,

  `idProject` INT NOT NULL ,

  `dtDateSearch` DATETIME NULL ,

  `strSearch` VARCHAR(50) NULL ,

  PRIMARY KEY (`idProjectSearch`) ,

  INDEX `fk_projectsearch_project1_idx` (`idProject` ASC) ,

  CONSTRAINT `fk_projectsearch_project1`

    FOREIGN KEY (`idProject` )

    REFERENCES `project` (`idProject` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfieldtime`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfieldtime` ;



CREATE  TABLE IF NOT EXISTS `formrecordfieldtime` (

  `idFormRecordFieldTime` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecordField` INT NOT NULL ,

  `tmValue` TIME NULL ,

  PRIMARY KEY (`idFormRecordFieldTime`) ,

  INDEX `fk_formrecordfielddatetime_formrecordfield1_idx` (`idFormRecordField` ASC) ,

  CONSTRAINT `fk_formrecordfielddatetime_formrecordfield10`

    FOREIGN KEY (`idFormRecordField` )

    REFERENCES `formrecordfield` (`idFormRecordField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordfieldtimeserie`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordfieldtimeserie` ;



CREATE  TABLE IF NOT EXISTS `formrecordfieldtimeserie` (

  `idFormRecordFieldTimeSerie` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecordField` INT NOT NULL ,

  `dtDateTime` DATETIME NULL ,

  `strValue` VARCHAR(100) NULL ,

  PRIMARY KEY (`idFormRecordFieldTimeSerie`) ,

  INDEX `fk_formrecordfieldtimeserie_formrecordfield1_idx` (`idFormRecordField` ASC) ,

  CONSTRAINT `fk_formrecordfieldtimeserie_formrecordfield1`

    FOREIGN KEY (`idFormRecordField` )

    REFERENCES `formrecordfield` (`idFormRecordField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userprojectworkgroup`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userprojectworkgroup` ;



CREATE  TABLE IF NOT EXISTS `userprojectworkgroup` (

  `idUser` INT NOT NULL ,

  `idProjectWorkgroup` INT NOT NULL ,

  INDEX `fk_userprojectworkgroup_user1_idx` (`idUser` ASC) ,

  INDEX `fk_userprojectworkgroup_projectworkgroup1_idx` (`idProjectWorkgroup` ASC) ,

  CONSTRAINT `fk_userprojectworkgroup_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_userprojectworkgroup_projectworkgroup1`

    FOREIGN KEY (`idProjectWorkgroup` )

    REFERENCES `projectworkgroup` (`idProjectWorkgroup` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userfilter`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userfilter` ;



CREATE  TABLE IF NOT EXISTS `userfilter` (

  `idUserFilter` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `idMarker` INT NULL ,

  `strName` VARCHAR(100) NULL ,

  PRIMARY KEY (`idUserFilter`) )

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userfilterclause`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userfilterclause` ;



CREATE  TABLE IF NOT EXISTS `userfilterclause` (

  `idUserFilterClause` INT NOT NULL AUTO_INCREMENT ,

  `idUserFilter` INT NOT NULL ,

  `idFormField` INT NOT NULL ,

  `intOperator` INT NOT NULL DEFAULT 1 ,

  `strValue` VARCHAR(100) NULL ,

  PRIMARY KEY (`idUserFilterClause`) ,

  INDEX `fk_userfilterclause_userfilter1_idx` (`idUserFilter` ASC) ,

  INDEX `fk_userfilterclause_formfield1_idx` (`idFormField` ASC) ,

  CONSTRAINT `fk_userfilterclause_userfilter1`

    FOREIGN KEY (`idUserFilter` )

    REFERENCES `userfilter` (`idUserFilter` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_userfilterclause_formfield1`

    FOREIGN KEY (`idFormField` )

    REFERENCES `formfield` (`idFormField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `toponymy`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `toponymy` ;



CREATE  TABLE IF NOT EXISTS `toponymy` (

  `idToponymy` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `dblLatitude` DOUBLE NULL ,

  `dblLongitude` DOUBLE NULL ,

  `strToponymy` VARCHAR(100) NULL ,

  `strCSS` VARCHAR(255) NULL ,

  PRIMARY KEY (`idToponymy`) ,

  INDEX `fk_maplabel_user1_idx` (`idUser` ASC) ,

  CONSTRAINT `fk_maplabel_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `useralert`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `useralert` ;



CREATE  TABLE IF NOT EXISTS `useralert` (

  `idUserAlert` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `idForm` INT NOT NULL ,

  `dtCreation` DATETIME NULL ,

  `strName` VARCHAR(100) NULL ,

  `blnOnRecordCreate` TINYINT(1) NOT NULL DEFAULT 0 ,

  `blnOnRecordUpdate` TINYINT(1) NOT NULL DEFAULT 0 ,

  `blnOnRecordDelete` TINYINT(1) NOT NULL DEFAULT 0 ,

  `strActionEmailTo` VARCHAR(45) NULL ,

  `intNotifyAfterDaysFromEvent` INT UNSIGNED NOT NULL DEFAULT 0 ,

  `blnActive` TINYINT(1) NOT NULL DEFAULT 1 ,

  PRIMARY KEY (`idUserAlert`) ,

  INDEX `fk_useralert_user1_idx` (`idUser` ASC) ,

  INDEX `fk_useralert_form1_idx` (`idForm` ASC) ,

  CONSTRAINT `fk_useralert_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_useralert_form1`

    FOREIGN KEY (`idForm` )

    REFERENCES `form` (`idForm` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `useralertclause`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `useralertclause` ;



CREATE  TABLE IF NOT EXISTS `useralertclause` (

  `idUserAlertClause` INT NOT NULL AUTO_INCREMENT ,

  `idUserAlert` INT NOT NULL ,

  `idFormField` INT NOT NULL ,

  `strOperador` VARCHAR(3) NULL ,

  `strValue` VARCHAR(100) NULL ,

  INDEX `fk_useralertclause_useralert1_idx` (`idUserAlert` ASC) ,

  INDEX `fk_useralertclause_formfield1_idx` (`idFormField` ASC) ,

  PRIMARY KEY (`idUserAlertClause`) ,

  CONSTRAINT `fk_useralertclause_useralert1`

    FOREIGN KEY (`idUserAlert` )

    REFERENCES `useralert` (`idUserAlert` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_useralertclause_formfield1`

    FOREIGN KEY (`idFormField` )

    REFERENCES `formfield` (`idFormField` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `useralertevent`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `useralertevent` ;



CREATE  TABLE IF NOT EXISTS `useralertevent` (

  `idUserAlertEvent` INT NOT NULL AUTO_INCREMENT ,

  `idUserAlert` INT NOT NULL ,

  `idEventType` INT NOT NULL ,

  `dtDateTime` DATETIME NULL ,

  `idUser` INT NULL ,

  `idFormRecord` INT NULL ,

  `dblLatitude` DOUBLE NULL ,

  `dblLongitude` DOUBLE NULL ,

  `txtDetails` TEXT NULL ,

  `blnRead` TINYINT(1) NOT NULL DEFAULT 0 ,

  `blnNotified` TINYINT(1) NOT NULL DEFAULT 0 ,

  INDEX `fk_useralertevents_useralert1_idx` (`idUserAlert` ASC) ,

  PRIMARY KEY (`idUserAlertEvent`) ,

  INDEX `fk_useralertevent_eventtype1_idx` (`idEventType` ASC) ,

  CONSTRAINT `fk_useralertevents_useralert1`

    FOREIGN KEY (`idUserAlert` )

    REFERENCES `useralert` (`idUserAlert` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_useralertevent_eventtype1`

    FOREIGN KEY (`idEventType` )

    REFERENCES `eventtype` (`idEventType` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `formrecordlog`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `formrecordlog` ;



CREATE  TABLE IF NOT EXISTS `formrecordlog` (

  `idFormRecordLog` INT NOT NULL AUTO_INCREMENT ,

  `idFormRecord` INT NOT NULL ,

  `idUser` INT NOT NULL ,

  `dtDateTime` DATETIME NULL ,

  `txtLog` TEXT NULL ,

  PRIMARY KEY (`idFormRecordLog`) ,

  INDEX `fk_formrecordlog_formrecord1_idx` (`idFormRecord` ASC) ,

  INDEX `fk_formrecordlog_user1_idx` (`idUser` ASC) ,

  CONSTRAINT `fk_formrecordlog_formrecord1`

    FOREIGN KEY (`idFormRecord` )

    REFERENCES `formrecord` (`idFormRecord` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION,

  CONSTRAINT `fk_formrecordlog_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;





-- -----------------------------------------------------

-- Table `userimageoverlay`

-- -----------------------------------------------------

DROP TABLE IF EXISTS `userimageoverlay` ;



CREATE  TABLE IF NOT EXISTS `userimageoverlay` (

  `idUserImageOverlay` INT NOT NULL AUTO_INCREMENT ,

  `idUser` INT NOT NULL ,

  `dblLatSW` DOUBLE NULL ,

  `dblLongSW` DOUBLE NULL ,

  `dblLatNE` DOUBLE NULL ,

  `dblLongNE` DOUBLE NULL ,

  `strName` VARCHAR(100) NULL ,

  `strFileName` VARCHAR(255) NULL ,

  PRIMARY KEY (`idUserImageOverlay`) ,

  INDEX `fk_userimageoverlay_user1_idx` (`idUser` ASC) ,

  CONSTRAINT `fk_userimageoverlay_user1`

    FOREIGN KEY (`idUser` )

    REFERENCES `user` (`idUser` )

    ON DELETE NO ACTION

    ON UPDATE NO ACTION)

ENGINE = InnoDB;







SET SQL_MODE=@OLD_SQL_MODE;

SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;

SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;



-- -----------------------------------------------------

-- Data for table `projectuserscope`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `projectuserscope` (`idProjectUserScope`, `strProjectUserScope`) VALUES (1, 'Just Me');

INSERT INTO `projectuserscope` (`idProjectUserScope`, `strProjectUserScope`) VALUES (2, 'My Workgroup');

INSERT INTO `projectuserscope` (`idProjectUserScope`, `strProjectUserScope`) VALUES (3, 'All Users');



COMMIT;



-- -----------------------------------------------------

-- Data for table `csstheme`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (1, 'united');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (2, 'classic');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (3, 'cyborg');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (4, 'journal');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (5, 'redy');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (6, 'simplex');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (7, 'slate');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (8, 'spacelab');

INSERT INTO `csstheme` (`idCSSTheme`, `strThemeName`) VALUES (9, 'cerulean');



COMMIT;



-- -----------------------------------------------------

-- Data for table `userlevel`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `userlevel` (`idUserLevel`, `strLevel`) VALUES (1, 'Visitor');

INSERT INTO `userlevel` (`idUserLevel`, `strLevel`) VALUES (2, 'Edit');

INSERT INTO `userlevel` (`idUserLevel`, `strLevel`) VALUES (3, 'Create, Edit, Delete');

INSERT INTO `userlevel` (`idUserLevel`, `strLevel`) VALUES (4, 'Project Administrator');



COMMIT;



-- -----------------------------------------------------

-- Data for table `datum`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (1, 'Airy', 6377563, 0.00667054);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (2, 'Australian National', 6378160, 0.006694542);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (3, 'Bessel 1841', 6377397, 0.006674372);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (4, 'Bessel 1841 Nambia', 6377484, 0.006674372);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (5, 'Clarke 1866', 6378206, 0.006768658);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (6, 'Clarke 1880', 6378249, 0.006803511);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (7, 'Everest', 6377276, 0.006637847);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (8, 'Fischer 1960 Mercury', 6378166, 0.006693422);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (9, 'Fischer 1968', 6378150, 0.006693422);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (10, 'GRS 1967', 6378160, 0.006694605);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (11, 'GRS 1980', 6378137, 0.00669438);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (12, 'Helmert 1906', 6378200, 0.006693422);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (13, 'Hough', 6378270, 0.00672267);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (14, 'International', 6378388, 0.00672267);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (15, 'Krassovsky', 6378245, 0.006693422);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (16, 'Modified Airy', 6377340, 0.00667054);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (17, 'Modified Everest', 6377304, 0.006637847);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (18, 'Modified Fischer 1960', 6378155, 0.006693422);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (19, 'South American 1969', 6378160, 0.006694542);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (20, 'WGS 60', 6378165, 0.006693422);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (21, 'WGS 66', 6378145, 0.006694542);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (22, 'WGS 72', 6378135, 0.006694318);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (23, 'WGS 84', 6378137, 0.00669437999014132);

INSERT INTO `datum` (`idDatum`, `strName`, `dblA`, `dblE2`) VALUES (24, 'SIRGAS 2000', 6378137, 0.00669437999014132);



COMMIT;



-- -----------------------------------------------------

-- Data for table `projectworkgroup`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `projectworkgroup` (`idProjectWorkgroup`, `idProject`, `strWorkgroup`) VALUES (0, 0, 'General');



COMMIT;



-- -----------------------------------------------------

-- Data for table `eventtype`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (1, 'UserLogin');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (2, 'UserLogout');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (3, 'FormInsert');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (4, 'FormDelete');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (5, 'FormUpdateMarkerChange');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (6, 'FormUpdateRename');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (7, 'FormUpdateFieldInsert');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (8, 'FormUpdateFieldRename');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (9, 'FormUpdateFieldDelete');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (10, 'UserInsert');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (11, 'UserDelete');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (12, 'UserUpdateEmail');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (13, 'RecordInsert');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (14, 'RecordUpdate');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (15, 'RecordDelete');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (16, 'RecordFileInsert');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (17, 'RecordFileDescriptionUpdade');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (18, 'RecordFileDelete');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (19, 'Search');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (20, 'UserJoinSubmit');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (21, 'UserActivated');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (22, 'UserBlocked');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (23, 'UserGroupInsert');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (24, 'UserGroupUpdate');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (25, 'UserGroupDelete');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (26, 'UserGroupJoin');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (27, 'UserGroupRelease');

INSERT INTO `eventtype` (`idEventType`, `strEventType`) VALUES (28, 'RecordSelect');



COMMIT;



-- -----------------------------------------------------

-- Data for table `marker`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (1, '1.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (2, '2.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (3, '3.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (4, '4.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (5, '5.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (6, '6.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (7, '7.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (8, '8.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (9, '9.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (10, '10.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (11, '11.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (12, '12.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (13, '13.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (14, '14.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (15, '15.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (16, '16.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (17, '17.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (18, '18.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (19, '19.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (20, '20.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (21, '21.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (22, '22.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (23, '23.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (24, '24.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (25, '25.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (26, '26.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (27, '27.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (28, '28.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (29, '29.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (30, '30.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (31, '31.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (32, '32.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (33, '33.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (34, '34.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (35, '35.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (36, '36.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (37, '37.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (38, '38.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (39, '39.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (40, '40.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (41, '41.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (42, '42.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (43, '43.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (44, '44.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (45, '45.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (46, '46.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (47, '47.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (48, '48.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (49, '49.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (50, '50.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (51, '51.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (52, '52.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (53, '53.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (54, '54.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (55, '55.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (56, '56.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (57, '58.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (58, '58.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (59, '59.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (60, '60.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (61, '61.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (62, '62.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (63, '63.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (64, '64.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (65, '65.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (66, '66.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (67, '67.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (68, '68.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (69, '69.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (70, '70.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (71, '71.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (72, '72.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (73, '73.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (74, '74.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (75, '75.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (76, '76.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (77, '77.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (78, '78.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (79, '79.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (80, '80.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (81, '81.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (82, '82.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (83, '83.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (84, '84.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (85, '85.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (86, '86.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (87, '87.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (88, '88.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (89, '89.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (90, '90.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (91, '91.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (92, '92.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (93, '92.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (94, '94.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (95, '95.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (96, '96.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (97, '97.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (98, '98.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (99, '99.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (100, '100.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (101, '101.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (102, '102.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (103, '103.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (104, '104.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (105, '105.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (106, '106.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (107, '107.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (108, '108.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (109, '109.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (110, '110.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (111, '111.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (112, '112.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (113, '113.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (114, '114.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (115, '115.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (116, '116.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (117, '117.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (118, '118.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (119, '119.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (120, '120.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (121, '121.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (122, '122.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (123, '123.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (124, '124.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (125, '125.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (126, '126.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (127, '127.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (128, '128.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (129, '129.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (130, '130.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (131, '131.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (132, '132.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (133, '133.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (134, '134.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (135, '135.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (136, '136.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (137, '137.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (138, '138.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (139, '139.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (140, '140.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (141, '141.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (142, '142.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (143, '143.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (144, '144.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (145, '145.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (146, '146.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (147, '147.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (148, '148.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (149, '149.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (150, '150.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (151, '151.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (152, '152.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (153, '153.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (154, '154.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (155, '155.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (156, '156.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (157, '157.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (158, '158.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (159, '159.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (160, '160.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (161, '161.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (162, '162.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (163, '163.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (164, '164.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (165, '165.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (166, '166.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (167, '167.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (168, '168.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (169, '169.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (170, '170.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (171, '171.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (172, '172.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (173, '173.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (174, '174.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (175, '175.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (176, '176.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (177, '177.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (178, '178.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (179, '179.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (180, '180.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (181, '181.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (182, '182.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (183, '183.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (184, '184.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (185, '185.png', NULL);

INSERT INTO `marker` (`idMarker`, `strMarkerFileName`, `idProject`) VALUES (186, '186.png', NULL);



COMMIT;



-- -----------------------------------------------------

-- Data for table `formfieldtype`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (1, 'Text');

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (2, 'Numeric');

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (3, 'Unichoice');

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (4, 'Multichoice');

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (5, 'Date');

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (6, 'Time');

INSERT INTO `formfieldtype` (`idFormFieldType`, `strFormFieldType`) VALUES (7, 'TimeSerie');



COMMIT;



-- -----------------------------------------------------

-- Data for table `device`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `device` (`idDevice`, `strName`) VALUES (1, 'Web');

INSERT INTO `device` (`idDevice`, `strName`) VALUES (2, 'Mobile');

INSERT INTO `device` (`idDevice`, `strName`) VALUES (3, 'API');

INSERT INTO `device` (`idDevice`, `strName`) VALUES (4, 'Social Network');



COMMIT;



-- -----------------------------------------------------

-- Data for table `shapetype`

-- -----------------------------------------------------

START TRANSACTION;

INSERT INTO `shapetype` (`idShapeType`, `strShapeType`) VALUES (1, 'Point');

INSERT INTO `shapetype` (`idShapeType`, `strShapeType`) VALUES (2, 'Line');

INSERT INTO `shapetype` (`idShapeType`, `strShapeType`) VALUES (3, 'Area');



COMMIT;